質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.55%

CentOS6.10 / python2.7 の環境でcloud-initがエラーになる

受付中

回答 1

投稿

  • 評価
  • クリップ 0
  • VIEW 82

lonoru

score 6

CentOS 6.10にpython2.7をインストールし、続いてcloud-initをインストールしたのですが
バージョン確認(cloud-init -v)にてエラーとなってしまいました。
エラーログは以下の通りです。

[root@ip-xxx-xxx-xxx-xxx bin]# cloud-init -v
Traceback (most recent call last):
  File "/usr/bin/cloud-init", line 43, in <module>
    from cloudinit import netinfo
  File "/usr/lib/python2.6/site-packages/cloudinit/netinfo.py", line 23, in <module>
    import cloudinit.util as util
  File "/usr/lib/python2.6/site-packages/cloudinit/util.py", line 59, in <module>
    from cloudinit import url_helper
  File "/usr/lib/python2.6/site-packages/cloudinit/url_helper.py", line 27, in <module>
    import requests
  File "/usr/lib/python2.6/site-packages/requests/__init__.py", line 53, in <module>
    from .packages.urllib3.contrib import pyopenssl
  File "/usr/lib/python2.6/site-packages/requests/packages/__init__.py", line 96, in load_module
    __import__(real_name)
  File "/usr/lib/python2.6/site-packages/urllib3/__init__.py", line 7, in <module>
    from .connectionpool import HTTPConnectionPool, HTTPSConnectionPool, connection_from_url
  File "/usr/lib/python2.6/site-packages/urllib3/connectionpool.py", line 100
    _blocking_errnos = {errno.EAGAIN, errno.EWOULDBLOCK}
                                    ^
SyntaxError: invalid syntax

エラーログにてpyhonが/usr/lib/python2.6〜となっているのでこれが原因ではと思っているのですが
これをあとからインストールした2.7に変更する方法が調べても見当たりませんでした。

試しに/usr/bin/pythonを/opt/rh/python27/root/usr/bin/pythonのシンボリックリンクに置き換えてみましたが
以下のエラーが発生し、もはやお手上げ状態です。

[root@ip-xxx-xxx-xxx-xxx bin]# cloud-init -v
Traceback (most recent call last):
  File "/usr/bin/cloud-init", line 39, in <module>
    from cloudinit import patcher
ImportError: No module named cloudinit

その他、pip等のバージョンは以下の通りです。

[root@ip-xxx-xxx-xxx-xxx bin]# pip -V
pip 20.0.2 from /opt/rh/python27/root/usr/lib/python2.7/site-packages/pip (python 2.7)

[root@ip-xxx-xxx-xxx-xxx bin]# which pip
/opt/rh/python27/root/usr/bin/pip

[root@ip-xxx-xxx-xxx-xxx bin]# python -V
Python 2.7.17

[root@ip-xxx-xxx-xxx-xxx bin]# which python
/opt/rh/python27/root/usr/bin/python

[root@ip-xxx-xxx-xxx-xxx bin]# which cloud-init
/usr/bin/cloud-init

[root@ip-xxx-xxx-xxx-xxx bin]# cat /etc/redhat-release
CentOS release 6.10 (Final)

上記事象について解決方法をご存知の方いらっしゃいましたら
ご教授のほどお願いいたします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

0

python2.7が必要なのでしょうか。

CentOS6のyumはpython2.6を利用しているためそちらにも影響が出てしまう可能性があります。(yumが利用できなくなっているかも)

面倒なことを考えたくない場合はCentOS7を利用されることをお勧めします。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2020/03/26 00:23

    ご回答ありがとうございます。
    私もそうしたいのは山々なのですが、現在構築しているサーバの要件としてCentOS6が必須となっているシステムのため変更できないのです・・・

    キャンセル

  • 2020/03/26 00:54

    なるほどむずかしいですね

    python2.6(rpm版)を残しつつpython2.7(ソース版)をインストールする方法を記述しているサイトもあるので参考にしてみてはどうでしょうか。

    キャンセル

  • 2020/03/26 13:27

    ありがとうございます。
    python2.7(ソース版)をビルドしてインストールするのも試してみたいと思います。

    キャンセル

  • 2020/03/26 14:30

    ここが参考になります

    さくらのVPSでCentOS6のPythonを2.7にアップデートする
    (http://elsur.xyz/centos6-python2_7-update)

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.55%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る